Unit Bncrs;
Interface
Uses Windows,WinSock,Classes,SysUtils,Socks;
Type
	PTelnetStruct		= ^TTelnetStruct;
	TTelnetStruct		=
		Record
			// RSock	:TClientSocket;
			Sock		:TSocket;
			RStr		:String;
			Dizzed	:Boolean;
		End;
Var
	Bouncers		:TStringList;
	BouncerPtrs	:TList;
Procedure TelnetThread(TelnetStruct:PTelnetStruct); StdCall;
Function NewBouncer(SourcePort,DestIP,DestPort:String):Boolean;
Function RemoveBouncer(BouncerPtr:Pointer):Boolean;
Implementation
Type
	PBouncerData = ^TBouncerData;
	TBouncerData =
		Record
			DestIP,DestPort			:String;
			Sock						:TServerSocket;
			ThreadID					:THandle;
		End;
	PSBouncerData = ^TSBouncerData;
	TSBouncerData =
		Record
			Sock						:TClientSocket;
			DestIP,DestPort			:String;
			ThreadID					:THandle;
		End;
Procedure TelnetThread(TelnetStruct:PTelnetStruct); StdCall;
	Var
	//	C	:String[255];
		I,D	:DWord;
		C	:Array[1..255] of Char;
	Begin
		While True do
			With TelnetStruct^ do Begin
				// RSock.WaitForData;
				I := Recv(Sock,C,SizeOf(C),0);
				If I = 0 then Begin
					Dizzed := True;
					While True do; // Hang thread
				End;
				Asm
					CLI
				End;
				For D := 1 to I do
					RStr := RStr + C[D];
				Asm
					STI
				End;
			End;
	End;
Procedure Bouncer(Parms:PSBouncerData); StdCall;
	Var
		CSock			:TClientSocket;
		Parms1,Parms2		:TTelnetStruct;
		P1Thread,P2Thread	:THandle;
		F,F2				:DWord;
		S				:String;
	Procedure KillThreads;
		Begin
			Asm
				CLI
			End;
			TerminateThread(P1Thread,0);
			TerminateThread(P2Thread,0);
			Asm
				STI
			End;
		End;
	Begin
		SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_BELOW_NORMAL);

		// Connect
		CSock := TClientSocket.Create;
		Try
			CSock.Connect(Parms.DestIP,Parms.DestPort);
		Except
			CSock.Free;
			With Parms.Sock do Begin
				Disconnect;
				Free;
			End;
			Exit;
		End;
		Asm
			CLI
		End;
		Parms.Sock.Peer := Parms.Sock.Peer + ' (BOUNCER)';
		Asm
			STI
		End;

		With Parms1 do Begin
			// RSock := CSock;
			Sock := CSock.Sock;
			RStr := '';
			Dizzed := False;
		End;
		F := 0;
		P1Thread := CreateThread(Nil,0,@TelnetThread,@Parms1,F,F2);
		With Parms2 do Begin
			// RSock := Parms.Sock;
			Sock := Parms.Sock.Sock;
			RStr := '';
			Dizzed := False;
		End;
		F := 0;
		P2Thread := CreateThread(Nil,0,@TelnetThread,@Parms2,F,F2);

		Repeat
			If Length(Parms2.RStr) > 0 then Begin
				Asm
					CLI
				End;
				S := Parms2.RStr;
				Parms2.RStr := '';
				Asm
					STI
				End;
				CSock.Write(PChar(S)^,Length(S));
			End;
			If Length(Parms1.RStr) > 0 then Begin
				Asm
					CLI
				End;
				S := Parms1.RStr;
				Parms1.RStr := '';
				Asm
					STI
				End;
				Parms.Sock.Write(PChar(S)^,Length(S));
			End;
			If (Parms2.Dizzed) or (Parms1.Dizzed) then Begin
				KillThreads;
				CSock.Disconnect;
				CSock.Free;
				Parms.Sock.Disconnect;
				Parms.Sock.Free;
				F := Parms.ThreadID;
				Dispose(Parms);
				TerminateThread(F,0);
			End;
		Until False;
	End;
Procedure BouncerThread(Parms:PBouncerData); StdCall;
	Var
		Sock		:TServerSocket;
		F,F2		:DWord;
		BParms	:PSBouncerData;
	Label Reconn;
	Begin
		Sock := Parms.Sock;
		Sock.Listen;
		Reconn:
		With Sock do Begin
			WaitForConnection;
			F := 0;
			New(BParms);
			BParms.DestIP := Parms.DestIP;
			BParms.DestPort := Parms.DestPort;
			BParms.Sock := AcceptConnection;
			BParms.ThreadID := CreateThread(Nil,1000,@Bouncer,BParms,F,F2);
		End;
		Goto Reconn;
	End;
Function NewBouncer(SourcePort,DestIP,DestPort:String):Boolean;
	Var
		Parms	:PBouncerData;
		F,F2		:DWord;
	Begin
		Result := True;
		New(Parms);
		Try
			Parms.Sock := TServerSocket.Create(SourcePort);
			Parms.DestIP := DestIP;
			Parms.DestPort := DestPort;
			F := 0;
			Parms.ThreadID := CreateThread(Nil,1000,@BouncerThread,Parms,F,F2);
		Except
			Dispose(Parms);
			Result := False;
			Exit;
		End;
		Asm
			CLI
		End;
		Bouncers.Add(SourcePort + ' -> ' + DestIP + ':' + DestPort);
		BouncerPtrs.Add(Parms);
		Asm
			STI
		End;
	End;
Function RemoveBouncer(BouncerPtr:Pointer):Boolean;
	Var I:Integer;
	Begin
		I := BouncerPtrs.IndexOf(BouncerPtr);
		Result := I <> -1;
		If Result then Begin
			With TBouncerData(BouncerPtrs[I]^) do Begin
				Sock.Disconnect;
				Sock.Free;
				TerminateThread(ThreadID,0);
			End;
			Asm
				CLI
			End;
			Bouncers.Delete(I);
			BouncerPtrs.Delete(I);
			Asm
				STI
			End;
		End;
	End;
Begin
	Bouncers := TStringList.Create;
	BouncerPtrs := TList.Create;
End.
