Unit IDS; // Ident Server
Interface
Function SetupIdentserver(OS,Username:String):String;
Function ShutdownIdentserver:String;
Function IdentserverInfos:String;
Implementation
Uses Windows,WinSock,Socks;
Type
	PServerParams			= ^TServerParams;
	TServerParams			=
		Record
			OS,Username	:String;
			Server		:TServerSocket;
			Client		:TClientSocket; // Only passed to ClientThread proc.
			Thread		:THandle;
		End;
Var
	IdentserverOnline		:Boolean;
	ServerParms			:PServerParams;
Procedure ClientThread(Parms:PServerParams); StdCall;
	Var
		S	:String;
		C	:Array[0..99] of Char;
	Begin
		S := '';
		Repeat
			Parms.Client.WaitForData;
			Parms.Client.Read(C,100);
			S := S + C;
		Until Pos(#13,S) > 0;
		S := Copy(S,1,Pos(#13,S) - 1) + ' : USERID : ' + Parms.OS + ' : ' + Parms.UserName + #13#10;
		Parms.Client.Write(PChar(S)^,Length(S));
		Parms.Client.DestroyEx;
		Dispose(Parms);
		ExitThread(0);
	End;
Procedure Thread(ServerParms:PServerParams); StdCall;
	Var
		F,F2		:DWord;
		Parms	:PServerParams;
	Begin
		SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_IDLE);
		ServerParms.Server.Listen;
		Repeat
			With ServerParms.Server do Begin
				WaitForConnection;
				New(Parms);
				Parms^ := ServerParms^;
				Parms.Client := AcceptConnection;
				F := 0;
				CreateThread(Nil,0,@ClientThread,Parms,F,F2);
			End;
		Until False;
	End;
Function SetupIdentserver(OS,Username:String):String;
	Var F,F2:DWord;
	Begin
		Result := '';
		If IdentserverOnline then
			Result := Result + ShutdownIdentserver + #13#10;
		Try
			// GetMem(ServerParms,SizeOf(ServerParms^));
			New(ServerParms);
			ServerParms.Server := TServerSocket.Create('113');
			ServerParms.OS := OS;
			ServerParms.Username := Username;
			F := 0;
			ServerParms.Thread := CreateThread(Nil,0,@Thread,ServerParms,F,F2);
			IdentserverOnline := True;
			Result := Result + 'Server online'#13#10;
		Except
			Result := Result + 'Fail'#13#10;
		End;
	End;
Function ShutdownIdentserver:String;
	Begin
		If IdentserverOnline then Begin
			TerminateThread(ServerParms.Thread,0);
			ServerParms.Server.Free;
			Dispose(ServerParms);
			IdentserverOnline := False;
			Result := 'Server shutdown'#13#10;
		End Else
			Result := 'No server to shut down!'#13#10;
	End;
Function IdentserverInfos:String;
	Begin
		If not IdentserverOnline then
			Result := 'No server online.'#13#10
		Else
			Result := 'Server running. OS "' + ServerParms.OS + '", Username "' + ServerParms.Username + '".'#13#10;
	End;
Begin
	IdentserverOnline := False; // This shouldn't be needed, but ..
End.
