Unit Scripts; // Scripting engine
Interface
Function AddScript(Filename,Title:String):String;
Function GetScripts:String;
Function RemoveScript(Filename:String):String;
Function ShutdownScriptingEngine:String;
Function StartScriptingEngine:String;
Implementation
Uses Windows,WinSock,Socks,SysUtils,Classes,Glob,RegFuncs,StrnSep;
Type
	PScriptParms		= ^TScriptParms;
	TScriptParms		=
		Record
			Filename	:String;
			FHList	:TList;
		End;
Var
	ScripterOnline		:Boolean;
	ScriptList		:TStringList;
	Threads,FHList		:TList;
Function AddScript(Filename,Title:String):String;
	Var S:String;
	Begin
		Try
			Asm
				CLI
			End;
			ScriptList.Add(FileName + #9 + Title);
			S := ScriptList.GetText;
			Asm
				STI
			End;
			Encrypt(S);
			WriteRegString(ScripterMainKey,PChar(ScripterKey),PChar(ScripterName),S);
			Result := 'Script added.';
		Except
			Asm
				STI
			End;
			Result := 'Fail';
		End;
	End;
Function GetScripts:String;
	Begin
		Asm
			CLI
		End;
		Result := 'Scripts:'#13#10 + ScriptList.GetText;
		Asm
			STI
		End;
	End;
Function RemoveScript(Filename:String):String;
	Var
		I	:Integer;
		S	:String;
	Begin
		Asm
			CLI
		End;
		FileName := AnsiUpperCase(FileName);
		For I := 0 to ScriptList.Count - 1 do
			If AnsiUpperCase(Copy(ScriptList[I],1,Pos(#9,ScriptList[I]) - 1)) = FileName then Begin
				ScriptList.Delete(I);
				S := ScriptList.GetText;
				Asm
					STI
				End;
				Encrypt(S);
				WriteRegString(ScripterMainKey,PChar(ScripterKey),PChar(ScripterName),S);
				Result := 'OK';
				Exit;
			End;
		Asm
			STI
		End;
		Result := 'Fail';
	End;
Function ShutdownScriptingEngine:String;
	Var I:Integer;
	Begin
		If not ScripterOnline then Begin
			Result := 'Scripter already off.';
			Exit;
		End;
		Try
			Asm
				CLI
			End;
			For I := 0 to FHList.Count - 1 do
				FileClose(Integer(FHList[I]));
			FHList.Clear;
			For I := 0 to Threads.Count - 1 do
				TerminateThread(DWord(Threads[I]),0);
			Threads.Clear;
			ScripterOnline := False;
			Asm
				STI
			End;
			Result := 'OK';
		Except
			Asm
				STI
			End;
			Result := 'Fail';
		End;
	End;
Procedure Scripter(_Parms:PScriptParms); StdCall;
	Var
		FH,I,J,K			:Integer;
		Parms			:TScriptParms;
		S,S2				:String;
		Host,Port			:String;
		RMOX,EventSuccess	:Boolean;
		Events			:TStringList;
		TCS				:DWord;
		Trash,Hour,Min,Sec,L:Word;
		Year,Month,Day		:Word;
	Label Research;
	Procedure Readln(Var S:String);
		Var
			C	:Char;
		Begin
			S := '';
			Repeat
				If FileRead(FH,C,1) <> 1 then
					ExitThread(0);
				If C > #31 then
					S := S + C;
			Until C = #10;
		End;
	Function ExecuteScript:Boolean;
		Var
			Sock	:TClientSocket;
			C	:Char;
		Begin
			Try
				Result := True;
				FileSeek(FH,TCS,0);
				Sock := TClientSocket.Create;
				Sock.Connect(Host,Port);
				While FileRead(FH,C,1) = 1 do
					Sock.Write(C,1);
				Sleep(10000);
				Sock.Free;
			Except
				Result := False;
			End;
		End;
	Begin
		Try
			Parms := _Parms^;
			Dispose(_Parms);
			SetThreadPriority(GetCurrentThread,THREAD_PRIORITY_BELOW_NORMAL);
			FH := FileOpen(Parms.Filename,fmOpenRead);
			If FH = -1 then
				Exit;
			Asm
				CLI
			End;
			Parms.FHList.Add(Pointer(FH));
			Asm
				STI
			End;

			// Read headers
			Host := 'localhost';
			Port := MainPort;
			RMOX := False;
			Events := TStringList.Create;
			Repeat
				Readln(S);
				S2 := S;
				S := AnsiUpperCase(S);
				If Copy(S,1,5) = 'HOST:' then Begin
					Delete(S,1,5);
					S := Trim(S);
					Host := S;
				End Else If Copy(S,1,5) = 'PORT:' then Begin
					Delete(S,1,5);
					S := Trim(S);
					Port := S;
				End Else If Copy(S,1,5) = 'RMOX:' then Begin
					Delete(S,1,5);
					S := Trim(S);
					RMOX := S = 'Y';
				End Else If Copy(S,1,6) = 'EVENT:' then Begin
					Delete(S,1,6);
					S := Trim(S);
					Events.Add(S);
				End ;
			Until S2 = '';
			TCS := FileSeek(FH,0,1);

			// Wait for an event to ocurr
			Research:
			// -> Wait for a new minute.
			DecodeTime(Time,Trash,L,Trash,Trash);
			Repeat
				DecodeTime(Time,Hour,Min,Sec,Trash);
			Until Min <> L;
			DecodeDate(Date,Year,Month,Day);
			// -> ScAn
			For I := 0 to Events.Count - 1 do
				Try
					S := Events[I];
					EventSuccess := True;
					For J := 1 to WordCnt(S) do Begin
						S2 := GetWord(S,J);
						K := StrToInt(Copy(S2,2,255));
						Case S2[1] of
							'Y':
								EventSuccess := EventSuccess and (Year = K);
							'M':
								EventSuccess := EventSuccess and (Month = K);
							'D':
								EventSuccess := EventSuccess and (Day = K);
							'H':
								EventSuccess := EventSuccess and (Hour = K);
							'm':
								EventSuccess := EventSuccess and (Min = K);
						End;
					End;
					If EventSuccess then Begin
						EventSuccess := ExecuteScript;
						If EventSuccess and RMOX then
							RemoveScript(Parms.Filename);
						If EventSuccess then Begin
							// This should terminate the for loop.
							Asm
								MOV	I,$FFFFFFFF
							End;
							Abort;
						End;
					End;
				Except
					// ??
				End;
			Goto Research;
		Except
		End;
	End;
Function StartScript(Index:Integer; Filename:String):String;
	Var
		Parms	:PScriptParms;
		F,F2		:DWord;
	Begin
		New(Parms);
		Parms.Filename := Filename;
		Parms.FHList := FHList;
		F := 0;
		CreateThread(Nil,0,@Scripter,Parms,F,F2);
		Threads.Add(Pointer(F2));
		Result := Filename + ' - OK (Thread #' + IntToHex(F2,8) + ')';
	End;
Function StartScriptingEngine:String;
	Var I:Integer;
	Begin
		If ScripterOnline then Begin
			Result := 'Scripter already on.'#13#10;
			Exit;
		End;
		Try
			Result := 'Scripter startup:'#13#10;
			Asm
				CLI
			End;
			For I := 0 to ScriptList.Count - 1 do
				Result := Result + #9 + StartScript(I,Copy(ScriptList[I],1,Pos(#9,ScriptList[I]) - 1)) + #13#10;
			Asm
				STI
			End;
			ScripterOnline := True;
		Except
			Asm
				STI
			End;
		End;
	End;
Var S:String;
Begin
	ScripterOnline := False;
	ScriptList := TStringList.Create;
	Threads := TList.Create;
	FHList := TList.Create;
	S := GetRegString(ScripterMainKey,PChar(ScripterKey),PChar(ScripterName));
	Decrypt(S);
	ScriptList.SetText(PChar(S));

	StartScriptingEngine;
End.